function [vals,inds] = find1dLocalMax(c,th)
% Function to find 1d local Maxima of an array
  if (size(c,1) ~= 1 && size(c,2) ~=1)
    disp('!ERROR, should input a 1D vector');
    exit(0);
  end
vals = []; inds = [];
% To find local Max, just calculate if one point is bigger than both its
% neighbors, the calculation excludes two endpoints.
biggerth    = (c(2:end-1) >th);
biggerleft  = (c(2:end-1) - c(1:end-2)) >=0;
biggerright = (c(2:end-1) - c(3:end) )  >=0;
sel = biggerth & biggerleft & biggerright;
%N = sum(sel(:));
npt  = length(c);
vals = c(sel);
t = (1:1:npt); inds = t(sel);
[vals ord] = sort(vals,'descend');
inds = inds(ord);
end
