function [index, dist] = findClosestIndex(ptscoord, newpt)
  % Calculate the index in the pt set "ptscoord" that is closest to newpt
  % ptscoord is n by 2 matrix, new pt is m by 2 matrix
  n = size(ptscoord,1); m = size(newpt,1);
  assert(size(ptscoord,2)==2 && size(newpt,2)==2 );
  %Calculate the distance matrix, which is n by m matrix
  VIx = repmat(ptscoord(:,1),1,m);
  VIy = repmat(ptscoord(:,2),1,m);
  VJx = repmat(newpt(:,1)',n,1);
  VJy = repmat(newpt(:,2),n,1);
  
  % Then subtract each coord.
  Vx = VIx - VJx;
  Vy = VIy - VJy;
  % Then calc r^2 for each (i,j) pair
  Vr = Vx(:).*Vx(:) + Vy(:).*Vy(:);
  Vr = sqrt(Vr+eps);
  Vrs  = reshape(Vr,[n m]);
  
  %Find the minimum for each column
  [dist,index] = min(Vrs); 
end
