% Shape deformation using the bending energy and SVM regression as in Song
% Wang's paper.
%% Clean All
close all; clear all;

%% Add environment
addpath ./adam1;
addpath ~/codeMatlab/nick;
set(0,'DefaultTextFontSize',14);
set(0,'DefaultAxesFontSize',14);

%% Read in the seismic images with segmented results, First 2D
% Notice that it could be 3D.
[hisI, imgI3]  = readSep('imgI3d.H');
%[hisI, envI3] = readSep('envI.H');
%%
[hisI,  segI3] = readSep('segI3d.H');
[hisI,  DsegI3] = readSep('DsegI3d.H');

%% Create the downsized version, not necessary.
scale = 0.5;
% segsT = (imresize(segT,scale,'nearest'));

%% Create bw for the segmentation, extract boundary pts, and plot those boundary pts
% overlayed with the original image.
markerDsRate = 2;
nslices = size(imgI3,3);

%%
for indSlice = 1:1:nslices
  segI = segI3(:,:,indSlice);
  imgI = imgI3(:,:,indSlice);
  segI = (segI)/max(segI(:));
  
  %Might downsample it
  
  %make black white image
  thres = 1/50.0*49.00;
  Im = im2bw(segI,thres); 
  
  %extract boundaries.
  dim = size(Im);
  nx = dim(2); nz = dim(1);
  Im = bwareaopen(Im,200); %remove the small isolated bodies.
  [B,L] = bwboundaries(Im,'noholes');
  bw_bnd = false(dim);
  bnd_coord_f = B{1};
  
  %Show the markers. 
  markerT = bnd_coord_f(1:markerDsRate:end,:);
  
  
%  if (indSlice == 9 || indSlice == 1)
    %plot the markers-boundary and the image at the same time.
    clips = quantile(imgI(:),[0.03 0.97]);
    imshow(imgI, clips); hold on; plot(markerT(:,2),markerT(:,1),'b','LineWidth',2); hold off;

    % print out the figures using dprt
    print(gcf,'-dpng',['oldSegOverlay_' num2str(nslices+1-indSlice)]);
%  end
end

%%
for indSlice = 1:1:nslices
  segI = DsegI3(:,:,indSlice);
  imgI = imgI3(:,:,indSlice);
  segI = (segI)/max(segI(:));
  
  %Might downsample it
  
  %make black white image
  thres = 1/50.0*49.00;
  Im = im2bw(segI,thres); 
  
  %extract boundaries.
  dim = size(Im);
  nx = dim(2); nz = dim(1);
  Im = bwareaopen(Im,200); %remove the small isolated bodies.
  [B,L] = bwboundaries(Im,'noholes');
  bw_bnd = false(dim);
  bnd_coord_f = B{1};
  
  %Show the markers. 
  markerT = bnd_coord_f(1:markerDsRate:end,:);
  
  %if (indSlice == 9 || indSlice == 1)
    %plot the markers-boundary and the image at the same time.
    clips = quantile(imgI(:),[0.03 0.97]);
    imshow(imgI, clips); hold on; plot(markerT(:,2),markerT(:,1),'b','LineWidth',2); hold off;
    pause(0.5);
    % print out the figures using dprt
    print(gcf,'-dpng',['defmSegOverlay_' num2str(nslices+1-indSlice)]);
 % end
end

