%% This line shows how to find the index of some specific marker
[index,dist] = findClosestIndex(markerT,fliplr(ginput(1)))


%% Explore the characteristic of the thin-plate spline function
% Draw a circle, dilate it, and see what it looks like
n = 64; t = linspace(0,2*pi,n+1); t(end) = [];
values = [cos(t); sin(t)];
centers = values;
m = 32;
v1 = centers(:,1:m); v2 = 1.2*v1; v2 = v2 .* (1.0+0.1*repmat(rand(1,m)-0.5,2,1)); %Add some randomness
st1 = tpaps(v1,v2(2,:),1); fnplt(st1);
hold on;
vals = fnval(st1,centers(:,m+1:end));
plot3(values(1,m+1:end),values(2,m+1:end),vals,'wo','markerfacecolor','k')
plot3(v1(1,:),v1(2,:),v2(2,:),'wo','markerfacecolor','r');
hold off;

st = tpaps(v1,v2,1); fnplt(st1);
vals = fnval(st,centers(:,m+1:end));
scatter(v2(1,:),v2(2,:),'r'); hold on;
scatter(vals(1,:),vals(2,:),'b');
scatter(centers(1,:),centers(2,:),'filled','k'); axis equal;

%quiver3(values(1,:),values(2,:),vals,zeros(1,n),zeros(1,n), noisyvals-avals,'r'), hold off


